#include "stdafx.h"

HMODULE hMod;
typedef void fnHolder(void);
fnHolder * I2C_Create;
fnHolder * I2C_SetSlave;
fnHolder * I2C_ReadSeq;
fnHolder * AudioDecoder_Create;
fnHolder * AudioDecoder_SetLoopbackPath;
char AudioDecoder_Space [100];
char I2C_Space [100];


bool InitAPI(void)
{
    hMod = LoadLibrary("34api.dll");
    if (!hMod) return false;
    I2C_Create = (fnHolder *) GetProcAddress(hMod,"??0CVampI2c@@QAE@KH@Z");
    I2C_SetSlave = (fnHolder *) GetProcAddress(hMod,"?SetSlave@CVampI2c@@QAEXH@Z");
    I2C_ReadSeq = (fnHolder *) GetProcAddress(hMod,"?ReadSeq@CVampI2c@@QAE?AW4eI2cStatus@@PAEH@Z");
    AudioDecoder_Create = (fnHolder *) GetProcAddress(hMod, "??0CVampAudioStream@@QAE@K@Z");
    AudioDecoder_SetLoopbackPath = (fnHolder *) GetProcAddress(hMod,"?SetLoopbackPath@CVampAudioStream@@QAEJW4AInput@@@Z");
    _asm
    {
        xor eax,eax
        push eax
        push eax
        mov ecx,offset I2C_Space
        call I2C_Create
        xor eax,eax
        push eax
        mov ecx,offset AudioDecoder_Space
        call AudioDecoder_Create
    }
    return true;
}

long GetSignalStrength(void)
{
    long SignalStrength;
    _asm
    {
        push 0xc1
        mov ecx,offset I2C_Space
        call I2C_SetSlave
        push 1
        lea eax,SignalStrength
        push eax
        mov ecx,offset I2C_Space
        call I2C_ReadSeq
    }
    return (SignalStrength & 0xff);
}

void SetMute713x(bool bMute)
{
    _asm
    {
        xor eax,eax
        mov al,bMute
        mov ecx,offset AudioDecoder_Space
        push eax
        call AudioDecoder_SetLoopbackPath
    }

	// Chcel som vypnut aj linkovy vstup na mixeri, aby to nepukalo,
	// ale kaslem na to. Na poziadanie dorobim :)

	/*
    HMIXER mixer;
    MIXERCAPS caps;
    MIXERLINE line;
    line.cbStruct = sizeof(line);
    if (mixerOpen(&mixer,0,0,0,MIXER_OBJECTF_MIXER) == MMSYSERR_NOERROR)
    {
        mixerGetDevCaps(UINT(mixer),&caps,sizeof(caps));
        for (UINT i=0; i<caps.cDestinations; i++)
        {
            line.dwDestination = i;
            mixerGetLineInfo(HMIXEROBJ(mixer),&line,MIXER_GETLINEINFOF_DESTINATION + MIXER_OBJECTF_HMIXER);

        }
        mixerClose(mixer);
    }
	*/

}

